#ifndef UTILS_RAWMEM_HH
#define UTILS_RAWMEM_HH

namespace utils
{
    template<typename T>
    struct Struct
    {
	T t;
    };

    class Unknown;
    
    union align_t
    {
	bool b;
	char c;
	short s;
	int i;
	long l;
	wchar_t w;
	float f;
	double d;
	long double ld;
	void* vp;
	void (*fp)();
	void (Unknown::*mfp)();
	Unknown* (Unknown::*mdp);
	Struct<bool> sb;
	Struct<char> sc;
	Struct<short> ss;
	Struct<int> si;
	Struct<long> sl;
	Struct<wchar_t> sw;
	Struct<float> sf;
	Struct<double> sd;
	Struct<long double> sld;
	Struct<void*> svp;
	Struct<void (*)()> sfp;
	Struct<void (Unknown::*)()> smfp;
	Struct<Unknown* (Unknown::*)> smdp;
    };
    
    template<typename T>
    union RawMem
    {
	char data[sizeof(T)];
	align_t align;
    };
}


#endif
